'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Jos Roca's FreeBasic AfxStr routines ported for use with bc9Basic strings 
' by James C. Fuller 08/11/2016
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Work in progess
'==============================================================================
' I would have liked to use the msvcrt functions but I got errors on redefinition
' with my proto
$CCODE UDT
	#ifndef DQ
		static char DQ [2] = {34,0};
	#endif
$CCODE
$IFUSE USE_STRSTR
$CCODE UDT
char* StrStr(char *str, char *substr)
{
	  while (*str) 
	  {
		    char *Begin = str;
		    char *pattern = substr;
		    
		    // If first character of sub string match, check for whole string
		    while (*str && *pattern && *str == *pattern) 
			{
			      str++;
			      pattern++;
		    }
		    // If complete sub string match, return starting address 
		    if (!*pattern)
		    	  return Begin;
		    	  
		    str = Begin + 1;	// Increament main string 
	  }
	  return NULL;
}
char* StriStr(char *str, char *substr)
{
	  while (*str) 
	  {
		    char *Begin = str;
		    char *pattern = substr;
		    
		    // If first character of sub string match, check for whole string
		    while (tolower(*str) && tolower(*pattern) && tolower(*str) == tolower(*pattern)) 
			{
			      str++;
			      pattern++;
		    }
		    // If complete sub string match, return starting address 
		    if (!*pattern)
		    	  return Begin;
		    	  
		    str = Begin + 1;	// Increament main string 
	  }
	  return NULL;
}

$CCODE
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxStrRetainAny
'------------------------------------------------------------------------------
Function AfxStrRetainAny(fsMainStr As fstring,fsMatchStr As fstring) As fstring
	Dim As Long nPos,i
	Raw As fstring fsRetStr
	If fsMainStr.Len() = 0 OR fsMatchStr.Len() = 0 Then
		Function = fsRetStr
	EndIf
	For i = 1 To fsMainStr.Len()
		nPos = fsMatchStr.InStr(fsMainStr.Mid(i,1),_false,_true)
		If nPos Then
			'szStr$ = szStr$ & Mid$(szMainStr,i,1)
			fsRetStr += fsMainStr.Mid(i,1)
		EndIf
	Next
	
	Function = fsRetStr
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsNumeric
'------------------------------------------------------------------------------
' Retuns TRUE if c is a number (0-9), a numeric sign (+-) or a decimal point (.).
' Note: Works both with single characters and strings.
' ========================================================================================
FUNCTION AfxIsNumeric (c AS const char ptr) AS BOOL
	If Len(c) = 0 Then
		Function = FALSE
	EndIf
	Dim szStr$
	szStr$ = AfxStrRetainAny(c, "+-.0123456789")
	If szStr$  = c  Then
		Function = TRUE
	Else
		Function = FALSE
	EndIf
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxStrRemoveAny
'------------------------------------------------------------------------------
Function AfxStrRemoveAny(szMainStr As const char ptr,szMatchStr As const char ptr) As string
	Dim As int i
	Raw As int nLen = Len(szMainStr) 
	Dim szStr$ * ((nLen * 2) + 2)
	szStr$ = szMainStr$
	For i =  1 To nLen
		szStr$ = Remove$(szStr$,Mid$(szMatchStr$,i,1))
	Next
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrIRemoveAny
'------------------------------------------------------------------------------
Function AfxStrIRemoveAny(szMainStr As const char ptr,szMatchStr As const char ptr) As string
	Dim As int i
	Raw As int nLen = Len(szMainStr) 
	Dim szStr$ * ((nLen * 2) + 2)
	szStr$ = szMainStr$
	For i =  1 To nLen
		szStr$ = IRemove$(szStr$,Mid$(szMatchStr$,i,1))
	Next
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'Function FStrCSet(fsMainStr As fstring,nStringLen As Long,szPadChar As const char ptr = " ") As string
'	Dim szStr$
'	szStr$ = String$(nStringLen,ASC(szPadChar))
'	Mid$(szStr$,(nStringLen - fsMainStr.Len())/2 +1,fsMainStr.Len()) = fsMainStr.lpStr()
'	Function = szStr$
'End Function

'==============================================================================
$IFUSE USE_AfxStrCSet
'------------------------------------------------------------------------------
Function AfxStrCSet(szMainStr As const char ptr,nStringLen As Long,szPadChar As const char ptr = " ") As string
	'Dim As int nMainLen = ((nStringLen + 1)*2) 
	'Dim szStr$ * nMainLen
	
	Raw As int nMainLen = Len(szMainStr)
	Dim szStr$ * ((nStringLen+1)*2)
	szStr$ = String$(nStringLen,ASC(szPadChar))
	Mid$(szStr$,(nStringLen - Len(szMainStr))/2 +1,Len(szMainStr))= szMainStr$
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrClipLeft
'------------------------------------------------------------------------------
' Returns a string with nCount characters removed from the left side of the string.
' If nCount is less than one then the entire string is returned.
' Example:  AfxStrClipLeft("1234567890", 3) -> 4567890
'------------------------------------------------------------------------------
Function AfxStrClipLeft(szMainStr As const char ptr,nCount As Long) As string
	Raw As Long nLen = Len(szMainStr)
	If nCount <= 0 OR nLen = 0 Then
		Function = "" 
	EndIf
	nCount = iif(nLen < nCount,nLen,nCount)
	Function = Mid$(szMainStr,nCount +1)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrClipRight
'------------------------------------------------------------------------------
Function AfxStrClipRight(szMainStr As const char ptr,nCount As Long) As string
	Raw As Long nLen = Len(szMainStr)
	If nCount <= 0 OR nLen = 0 Then
		Function = "" 
	EndIf
	nCount = nLen - nCount
	nCount = iif(nLen < nCount,nLen,nCount)
	Function= Left$(szMainStr,nCount)	
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrClipMid
'------------------------------------------------------------------------------
Function AfxStrClipMid(szMainStr As const char ptr,nStart As Long,nCount As Long) As string
	Raw As Long nLen = Len(szMainStr)
	If nCount <= 0 OR nStart <= 0 Then
		Function = ""
	EndIf
	Function = Left$(szMainStr,nStart -1) & Mid$(szMainStr,nStart + nCount)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrWrap
'------------------------------------------------------------------------------
Function AfxStrWrap(szMainStr As const char ptr,szLeftChar As const char ptr,szRightChar As const char ptr) As string
	Function = szLeftChar & szMainStr & szRightChar
End Function
'------------------------------------------------------------------------------
Function AfxStrWrap(szMainStr As const char ptr,szChar As const char ptr = DQ) As string
	Function = szChar & szMainStr & szChar
End Function

$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrUnWrap
'------------------------------------------------------------------------------
' Removes paired characters to the beginning and end of a string.
' It is particularly useful for removing text with parenthesess, quotes, brackets, etc.
' For example: AfxStrUnWrap("<Paul>", "<", ">") results in Paul
' If only one unwrap character/string is specified then that character or string is used for both sides.
' For example: AfxStrUnWrap("'Paul'", "'") results in Paul
' If no wrap character/string is specified then double quotes are used.
' For example: AfxStrUnWrap("""Paul""") results in Paul
' ========================================================================================
FUNCTION AfxStrUnWrap (szMainStr As const char ptr,szLeftChar As const char ptr, szRightChar As const char ptr) As string
   Dim sStr$ 
   sStr$ =  LTRIM$(szMainStr,ASC(szLeftChar))
   sStr$ =  RTRIM$( sStr$,ASC(szRightChar))
   Function = sStr$ 
END FUNCTION
' ========================================================================================
' ========================================================================================
FUNCTION AfxStrUnWrap (szMainStr As const char ptr, szChar As const char ptr = DQ) AS string
   Dim sStr$ 
   sStr$ =  LTRIM$(szMainStr,ASC(szChar))
   sStr$ =  RTRIM$( sStr$,ASC(szChar))
   Function = sStr$ 
	
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrExtractAny
' Extract characters from a string up to a specific character.
' Returns a substring of szMainStr starting with its first character (or the character
' specified by nStart) and up to (but not including) the first occurrence of szMatchStr.
' szMatchStr specifies a list of single characters to be searched for individually, a
' match on any one of which will cause the extract operation to be performed up to that character.
' If szMatchStr is not present in szMainStr (or is null) then all of wszMainStr is returned.
' This function is case-sensitive.
' Example:  AfxStrExtractAny(1, "abacadabra","cd")

'------------------------------------------------------------------------------
Function AfxStrExtractAny(nStart As Long,szMainStr As const char ptr,szMatchStr As const char ptr) as string
	Dim As int nMainLen,nMatchLen,i,x,nPos
	Dim szStr$
	nMainLen = Len(szMainStr)
	nMatchLen = Len(szMatchStr)
	
	If nMainLen = 0 OR nMatchLen = 0  OR nStart = 0 OR nStart > nMainLen Then
		GOTO NULLEXIT
	EndIf
	If nStart < 0 Then 
		nStart = nMainLen + nStart + 1
	EndIf
	For i = nStart To nMainLen
		For x = 1 To nMatchLen
			If Mid$(szMainStr,i,1) = Mid$(szMatchStr,x,1) Then
				szStr$ = Mid$(szMainStr,nStart,i - nStart)
				Exit Nest
			EndIf
		Next
	Next
NULLEXIT:
	Function = szStr$	
End Function
'------------------------------------------------------------------------------
$ENDUSE
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'This next group has some equivalent bc9Basic function calls.
'The Fred Harris String also has some similar methods
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'==============================================================================
$IFUSE USE_AfxStrParseCount
' Returns the count of delimited fields from a string expression.
' If wszMainStr is empty (a null string) or contains no delimiter character(s), the string
' is considered to contain exactly one sub-field. In this case, AfxStrParseCount returns the value 1.
' Delimiter contains a string (one or more characters) that must be fully matched.
' Delimiters are case-sensitive.
' Example: DIM nCount AS LONG = AfxStrParseCount("one,two,three", ",")
'------------------------------------------------------------------------------
FUNCTION AfxStrParseCount (szMainStr As const char ptr, szDelimiter As const char ptr = ",") AS LONG
	Raw As Long nCount = 1, nPos = 1   
	Do
		nPos = Instr(szMainStr, szDelimiter,nPos)
			If nPos = 0 Then
				Exit Do
			EndIf
		nCount += 1
		nPos += LEN(szDelimiter)
	Loop
	Function = nCount
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrParseCountAny
'------------------------------------------------------------------------------
' Return the count of delimited fields from a string expression.
' If wszMainStr is empty (a null string) or contains no delimiter character(s), the string
' is considered to contain exactly one sub-field. In this case, AfxStrParseCountAny returns the value 1.
' Delimiter contains a set of characters (one or more), any of which may act as a delimiter character.
' Delimiters are case-sensitive.
' Example: DIM nCount AS LONG = AfxStrParseCountAny("1;2,3", ",;")
' ========================================================================================
FUNCTION AfxStrParseCountAny (szMainStr As const char ptr, szDelimiter As const char ptr = ",") AS LONG
	Raw As Long nCount = 1,nPos = 1
	Do
		nPos = InstrAny(szMainStr,szDelimiter,nPos)
		If nPos = 0 Then
			Exit Do
		EndIf
		nCount += 1
		nPos += Len(szDelimiter)
	Loop
	Function = nCount
END FUNCTION

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxStrParse
'------------------------------------------------------------------------------
Function AfxStrParse(szMainStr As const char ptr,Item As int, szDelimiter As const char ptr = ",") As string
	Function = StrToken$(szMainStr,szDelimiter,Item)
End Function
'------------------------------------------------------------------------------
$ENDUSE
