'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Jos Roca's FreeBasic AfxStr routines ported for use with Fred's String class
' by James C. Fuller 08/11/2016
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Work in progess
'==============================================================================
$IFUSE USE_STRSTR
$CCODE UDT
char* StrStr(char *str, char *substr)
{
	  while (*str) 
	  {
		    char *Begin = str;
		    char *pattern = substr;
		    
		    // If first character of sub string match, check for whole string
		    while (*str && *pattern && *str == *pattern) 
			{
			      str++;
			      pattern++;
		    }
		    // If complete sub string match, return starting address 
		    if (!*pattern)
		    	  return Begin;
		    	  
		    str = Begin + 1;	// Increament main string 
	  }
	  return NULL;
}
char* StriStr(char *str, char *substr)
{
	  while (*str) 
	  {
		    char *Begin = str;
		    char *pattern = substr;
		    
		    // If first character of sub string match, check for whole string
		    while (tolower(*str) && tolower(*pattern) && tolower(*str) == tolower(*pattern)) 
			{
			      str++;
			      pattern++;
		    }
		    // If complete sub string match, return starting address 
		    if (!*pattern)
		    	  return Begin;
		    	  
		    str = Begin + 1;	// Increament main string 
	  }
	  return NULL;
}

$CCODE
$ENDUSE
'==============================================================================
$IFUSE USE_FStrRemain
'------------------------------------------------------------------------------
'Function FStrRemain(fsMainStr AS fstring,fsMatchStr As fstring,nStart As Long = 1) As string
Function FStrRemain(fsMainStr AS fstring,fsMatchStr As fstring) As string
	Raw As char Ptr p = StrStr(fsMainStr.lpStr(),fsMatchStr.lpStr())
	If p Then
		p+= fsMatchStr.Len()
		Function = p
	EndIf
	Function = fsMainStr.lpStr()
End Function	
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrExtract
'------------------------------------------------------------------------------
Function FStrExtract(fsMainStr AS fstring,fsMatchStr As fstring) As string
	Function = Extract$(fsMainStr.lpStr(),fsMatchStr.lpStr())
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrRetainAny
'------------------------------------------------------------------------------
Function FStrRetainAny(fsMainStr As fstring,fsMatchStr As fstring) As string
	Raw As fstring fsTmp
	If fsMainStr.Len() = 0 OR fsMatchStr.Len() = 0 Then
		GOTO NullExit
	EndIf
	Dim As Long i,x,nPos
	For i = 1 To fsMainStr.Len()
		nPos = fsMatchStr.InStr(fsMainStr.Mid(i,1),_true,_true)
		If nPos Then
			fsTmp += fsMainStr.Mid(i,1)
		EndIf
	Next
NullExit:
	Function = fsTmp.lpStr()
	
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrIsNumeric
'------------------------------------------------------------------------------
Function FStrIsNumeric(c As fstring) As BOOL
	If c.Len() = 0 Then
		Function = FALSE
	EndIf
	
	Raw As fstring fstmp = FStrRetainAny(c,"+-.0123456789")
	If fstmp = c Then
		Function = TRUE
	Else
		Function = FALSE	
	EndIf

End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrRemove
'------------------------------------------------------------------------------
' Returns a copy of a string with strings removed.
' If wszMatchStr is not present in wszMainStr, all of wszMainStr is returned intact.
' This function is case sensitive.
' Example: DIM cws AS CWSTR = AfxStrRemove("[]Hello[]", "[]")
' ========================================================================================
FUNCTION FStrRemove (fsMainStr AS fstring,fsMatchStr As fstring,bCaseSensitive As _bool = _true) As string
	Raw As fstring fs = fsMainStr.Remove(fsMatchStr.lpStr(),bCaseSensitive) 
	Function = fs.lpStr()
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrRemoveAny
'------------------------------------------------------------------------------
Function FStrRemoveAny(fsMainStr AS fstring,fsMatchStr As fstring) As string
	Raw As fstring fs = fsMainStr.Remove(fsMatchStr.lpStr())
	Function = fs.lpStr()
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'$IFUSE USE_FStrReplace
''------------------------------------------------------------------------------
'Function FStrReplace(fsMainStr AS fstring,fsMatchStr As fstring,fsReplaceStr As fstring) As string
'	Raw As fstring fs = fsMainStr.Replace(fsMainStr.lpStr(),fsMatchStr.lpStr())
'	Function = fs.lpStr()
'End Function
''------------------------------------------------------------------------------
'$ENDUSE
'==============================================================================
$IFUSE USE_FStrShrink
'------------------------------------------------------------------------------
Function FStrShrink(fsStr As fstring,szMask As const char ptr = " ") As String
	Raw As fstring fs1
	If fsStr.Len() = 0 OR Len(szMask) = 0 Then
		GOTO NULLEXIT
	EndIf
	fs1 = fsStr
	fs1.Trim()
	fs1 = STRIM$(fs1.lpStr())
NULLEXIT:
	Function = 	fs1.lpStr()
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrCSet
'------------------------------------------------------------------------------
Function FStrCSet(fsMainStr As fstring,nStringLen As Long,szPadChar As const char ptr = " ") As string
	Dim szStr$
	szStr$ = String$(nStringLen,ASC(szPadChar))
	Mid$(szStr$,(nStringLen - fsMainStr.Len())/2 +1,fsMainStr.Len()) = fsMainStr.lpStr()
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrLSet
'------------------------------------------------------------------------------
Function FStrLSet(fsMainStr As fstring,nStringLen As Long,szPadChar As const char ptr = " ") As string
	Dim szStr$ 
	szStr$ = String$(nStringLen,ASC(szPadChar))
	Mid$(szStr$,1,fsMainStr.Len()) = fsMainStr.lpStr()
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrRSet
'------------------------------------------------------------------------------
Function FStrRSet(fsMainStr As fstring,nStringLen As Long,szPadChar As const char ptr = " ") As string
	Dim szStr$
	szStr$ = String$(nStringLen,ASC(szPadChar))
	Mid$(szStr$,nStringLen - fsMainStr.Len() + 1,fsMainStr.Len()) = fsMainStr.lpStr()
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrSplitPath
'------------------------------------------------------------------------------
Function FStrSplitPath(szOption As const char ptr,szFileSpec As const char ptr) As string
	Dim szStr$
	Dim As Long nPos
	If Len(szFileSpec) = 0 OR Len(szOption) = 0 Then
		GOTO NULLEXIT
	EndIf
	Select Case Ucase$(szOption)
		Case "PATH"
			nPos = InstrAnyRev(szFileSpec,":/\")
			If nPos Then
				szStr$ = Mid$(szFileSpec,1,nPos)
				Exit Select
			EndIf
		Case "NAME"
			'szStr$ = szFileSpec
			nPos = InstrAnyRev(szFileSpec,":/\")
			If nPos Then
				szStr$ = Mid$(szFileSpec,nPos + 1)	
			EndIf
			nPos = InstrRev(szStr$,".")
			If nPos Then
				szStr$ = Mid$(szStr$,1,nPos-1)			
			EndIf
		Case "NAMEX"
			nPos = InstrAnyRev(szFileSpec,":/\")
			If nPos Then
				szStr$ = Mid$(szFileSpec,nPos +1)
			Else
				szStr$ = szFileSpec
			EndIf
		Case "EXTN"
			nPos = InstrAnyRev(szFileSpec,":/\")
			If nPos Then
				szStr$ = Mid$(szFileSpec,nPos + 1)
			Else
				szStr$ = szFileSpec
			EndIf
			nPos = InstrRev(szStr$,".")
			If nPos Then
				szStr$ = Mid$(szStr$,nPos)
			Else
				szStr$ = ""
			EndIf
	End Select
NULLEXIT:
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrRepeat
'------------------------------------------------------------------------------
Function FStrRepeat(nCount As Long,szMainStr As const char Ptr) As string
	Raw As Long nLen = Len(szMainStr)
	Dim As Long i
	If nCount <= 0 OR nLen = 0 Then
		Function = "" 
	EndIf

	Dim szStr$ * ((nCount * nLen)*2)+2
	szStr$ = SPACE$(nCount * nLen)
	For i = 0 To nCount-1
		Mid$(szStr$,(i*nLen) + 1,nLen) = szMainStr$
	Next
	Function = szStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_FStrClipLeft
'------------------------------------------------------------------------------
Function FStrClipLeft(szMainStr As const char ptr,nCount As Long) As string
	Raw As Long nLen = Len(szMainStr)
	If nCount <= 0 OR nLen = 0 Then
		Function = "" 
	EndIf
	nCount = iif(nLen < nCount,nLen,nCount)
	Function = Mid$(szMainStr,nCount +1)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'$IFUSE USE_
''------------------------------------------------------------------------------
'
''------------------------------------------------------------------------------
'$ENDUSE



