/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Fred's work
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

template <class datatype> class CArray            // This entity is a templated class for creating dynamic
{                                                 // multi-dimensional arrays of from one to four dimensions.
 public:                                          // It allows for a basic language type syntax for doing
 CArray() : pObjs(0)                              // the above.  GNU C++ compilers implement dynamic array
 {                                                // allocation but MS VC++ compilers don't.  Since I wanted
  this->iNumObjects=0;                            // to test compile with both I developed this class.
  d1=d2=d3=d4=0;
 }

 CArray(int i) : pObjs(0)                         // One Dimensional Array Constructor
 {
  this->iNumObjects=i;
  this->pObjs = NEW datatype[this->iNumObjects]();
  d1=i, d2=0, d3=0, d4=0;
 }

 CArray(int i, int j) : pObjs(0)                  // Two Dimensional Array Constructor
 {
  this->iNumObjects=i*j;
  this->pObjs = NEW datatype[this->iNumObjects]();
  d1=i, d2=j, d3=0, d4=0;
 }

 CArray(int i, int j, int k) : pObjs(0)           // Three Dimensional Array Constructor
 {
  this->iNumObjects=i*j*k;
  this->pObjs = NEW datatype[this->iNumObjects]();
  d1=i, d2=j, d3=k, d4=0;
 }

 CArray(int i, int j, int k, int l) : pObjs(0)    // Four Dimensional Array Constructor
 {
  this->iNumObjects=i*j*k*l;
  this->pObjs = NEW datatype[this->iNumObjects]();
  d1=i, d2=j, d3=k, d4=l;
 }

 datatype& operator()(int i)                      // One Dimensional Accessor
 {
  return pObjs[i];
 }

 datatype& operator()(int i, int j)               // Two Dimensional Accessor
 {
  return pObjs[i*d2 + j];
 }

 datatype& operator()(int i, int j, int k)        // Three Dimensional Accessor
 {
  return pObjs[i*d2 + j + k*d1*d2];
 }

 datatype& operator()(int i, int j, int k, int l) // Four Dimensional Accessor
 {
  return pObjs[i*d2 + j + k*d1*d2 + l*d1*d2*d3];
 }

 bool blnMemoryIsGood()
 {
  return !!pObjs;
 }

 int UBound(int iDim)
 {
  if(iDim==1)
     return d1-1;
  if(iDim==2)
     return d2-1;
  if(iDim==3)
     return d3-1;
  if(iDim==4)
     return d4-1;
  else
     return 0;
 }

 ~CArray()
 {
  if(this->pObjs)
     delete [] this->pObjs;
 }

 private:
 datatype* pObjs;       // pointer to the base memory allocation for array
 int       iNumObjects; // We'll need this to zero memory for non-class types
 int       d1;          // Dimension #1
 int       d2;          // Dimension #2
 int       d3;          // Dimension #3
 int       d4;          // Dimension #4
};


template<typename t1> void Output(CArray<t1>& Ar3)
{
 for(int h=0; h<=Ar3.UBound(3); h++)
 {
     for(int i=0; i<=Ar3.UBound(1); i++)
     {
         for(int j=0; j<=Ar3.UBound(2); j++)
             wprintf(L"%s\t",Ar3(i,j,h).lpStr());
         printf("\n");
     }
     printf("\n");
 }
}
