#pragma once

//#include <iostream>

using namespace std;

#define $NULL  L""
#define $COMMA L","
#define $SPACE L" "

#define long_proc typedef long (__stdcall *zProc)
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16))
//#define UBOUND(T) ((LONG) T.size())
#define UBOUND(T) sizeof(T)/sizeof(T[0]) 

long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

template <class T> void swap ( T& a, T& b ) {
    T c(a); a=b; b=c;
}

void reverse(WCHAR str[], long length) {
    int start = 0;
    int end = length -1;
    while (start < end) {
        swap(*(str + start), *(str + end));
        start++;
        end--;
    }
}

WCHAR* L2W(IN long num, IN WCHAR* str, IN long base) {
    long i = 0;
    BOOL isNegative = FALSE;

    /* Handle 0 explicitely, otherwise empty string is printed for 0 */
    if (num == 0) {
        str[i++] = L'0';
        str[i] = L'\0';
        return str;
    }

    // In standard itoa(), negative numbers are handled only with 
    // base 10. Otherwise numbers are considered unsigned.
    if (num < 0 && base == 10) {
        isNegative = TRUE;
        num = -num;
    }

    // Process individual digits
    while (num != 0) {
        long rem = num % base;
        str[i++] = (rem > 9) ? (rem-10) + L'a' : rem + L'0';
        num = num / base;
    }

    // If number is negative, append '-'
    if (isNegative) { str[i++] = L'-'; }

    str[i] = L'\0'; // Append string terminator

    // Reverse the string
    reverse(str, i);

    return str;
}

WCHAR* STRL(IN long N) {
    static WCHAR longstr[33] = {0};
    L2W(N, longstr, 10);
    return (WCHAR*)longstr;
}

//long find_wchar(IN WCHAR* sChar, IN WCHAR* sItem) {
//    long nRet = -1;
//    long K = 0, nLen = (long) wcslen(sChar);
//    for (K = 0; K < nLen; K++) {
//        if (sChar[K] == sItem[0]) { nRet = K; }
//    }
//    return nRet;
//}

//WCHAR* RTRIM$(IN WCHAR* sBuf, IN WCHAR* sChar) {
//    long nLength = (long) wcslen(sBuf);
//    long nLen = (long) wcslen(sChar);
//    if ((nLength) && (nLen)) {
//        while (nLength > 0) {
//            nLength -= 1;
//            if (find_wchar(sChar, &sBuf[nLength]) > -1) {
//                sBuf[nLength] = L'\0';
//            } else {
//                break;
//            }
//        }
//    }
//    return sBuf;
//}

//WCHAR* LTRIM$(IN WCHAR* sBuf, IN WCHAR* sChar) {
//    long nLength = (long) wcslen(sBuf);
//    long nLen = (long) wcslen(sChar);
//    if ((nLength) && (nLen)) {
//        WCHAR* szBuffer = new WCHAR[nLength];
//        ZeroMemory(szBuffer, nLength * sizeof(WCHAR));
//        long K = 0;
//        while (K < nLength) {
//            // This is the sChar ANY search version
//            if (find_wchar(sChar, &sBuf[K]) > -1) {
//                ++K;
//            } else {
//                break;
//            }
//        }
//
//        wmemcpy(szBuffer, sBuf + K, (nLength - K) * sizeof(WCHAR));
//        ZeroMemory(sBuf, nLength * sizeof(WCHAR));
//        wmemcpy(sBuf, szBuffer, nLength * sizeof(WCHAR));
//
//        delete [] szBuffer;
//    }
//    return sBuf;
//}

//WCHAR* TRIM$(IN WCHAR* sBuf, IN WCHAR* sChar) {
//    return LTRIM$(RTRIM$(sBuf, sChar), sChar);
//}

//void RemoveQuote(IN WCHAR* szName) {
//    long nSize = (long) wcslen(szName);
//    if ((nSize > 1) && (nSize <= MAX_PATH)) {
//        if (szName[0] == 34) {
//            WCHAR* szBuffer = new WCHAR[nSize];
//            ZeroMemory(szBuffer, nSize * sizeof(WCHAR));
//            wmemcpy(szBuffer, szName + 1, (nSize - 2) * sizeof(WCHAR));
//            ZeroMemory(szName, nSize * sizeof(WCHAR));
//            wmemcpy(szName, szBuffer, nSize * sizeof(WCHAR));
//            delete [] szBuffer;
//        }
//    }
//}

//WCHAR* CHR$(IN long n) {
//    static WCHAR bb[2] = { 0 };
//    bb[0] = n % 255;
//    return (WCHAR*) bb;
//}

//long INSTRPOS(IN WCHAR* sMain, IN WCHAR* sSearch) {
//    long sMainSize = (long) wcslen(sMain);
//    long sSearchSize = (long) wcslen(sSearch);
//    long nRet = 0;
//    if (sMainSize > sSearchSize) {
//        for ( int i = 0 ; i <= sMainSize - sSearchSize; ++i ) {
//             if (wcsncmp(&sMain[i], sSearch, sSearchSize) == 0 ) {
//                 nRet = i + 1;
//                 break;
//             }
//        }
//    }
//    return nRet;
//}

long dpi(IN long nPix) {
    static float ratio;
    if (ratio == 0) {
        HDC hDC = GetDC(0); ratio = (GetDeviceCaps(hDC, LOGPIXELSX) / 96.0f); ReleaseDC(0, hDC); 
    }
    return (long)(nPix * ratio);
}

DWORD FileSize(IN WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = {0};
    DWORD nRet = 0;
    if (wcslen(szFileSpec)) {
        HANDLE hFind;
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            nRet = fd.nFileSizeLow;
        }
    }
    return nRet;
}

LRESULT List_Add(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (hList) {
       //if (wcslen(zTmp)) { 
       nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp);
       //}
    }
    return nIndex;
}

long List_Count(IN HWND hList) {
    long nRet = 0;
    if (IsWindow(hList)) { nRet = (long) SendMessage(hList, LB_GETCOUNT, 0, 0); }
    return nRet;
}

LRESULT List_Delete(IN HWND hList, IN long nRow) {
    LRESULT lResult = SendMessage(hList, LB_DELETESTRING, nRow, 0);
    return lResult;
}
